from gi.repository import Gtk
from gi.repository import Gdk

def _destroy_cb(widget, data=None):
    Gtk.main_quit()

def __leave_notify_event_cb(widget, event):
    print 'leave: ', widget, event.mode

def __button_release_event_cb(widget, event):
    print 'button release: ', widget, event.button

window = Gtk.Window()
window.connect("destroy", _destroy_cb)
window.show()

box = Gtk.VBox()
window.add(box)
box.show()

model = Gtk.ListStore(str)
for icon in ['one', 'two', 'three']:
    model.append([icon])

treeview = Gtk.TreeView()
treeview.set_model(model)
box.add(treeview)
treeview.show()
treeview.connect('leave-notify-event',
                 __leave_notify_event_cb)
treeview.connect('button-release-event',
                 __button_release_event_cb)
#treeview.add_events(Gdk.EventMask.BUTTON_PRESS_MASK |
#                    Gdk.EventMask.TOUCH_MASK |
#                    Gdk.EventMask.BUTTON_RELEASE_MASK)

col = Gtk.TreeViewColumn()
treeview.append_column(col)

cell_text = Gtk.CellRendererText()
col.pack_start(cell_text, expand=True)
col.add_attribute(cell_text, 'text', 0)

button = Gtk.Button(label='Click me!')
box.add(button)
button.show()
button.connect('leave-notify-event',
               __leave_notify_event_cb)
button.connect('button-release-event',
               __button_release_event_cb)


Gtk.main()
